<template>

    <div id="index">

        <div class="search">
            <v-parallax height="600" dark src="@/assets/bg.jpg">
            <v-row align="center" justify="center" class="text-center">
                <span class="custom-title">Movies Library</span>
            </v-row>
                <v-row align="start" justify="center">
                    <v-col class="content">
                        <v-text-field dark class="font-weight-thin" label="Rechercher" type="text" v-model="search"/>
                        <v-btn v-on:click="GoToAddMovie()">Ajouter un film</v-btn>
                    </v-col>
                </v-row>
            </v-parallax>
        </div>

        <div class="movies">
            <div v-for="(movie) in filteredMovie"  v-bind:key="movie.id" class="movie">
                <movie :movie="movie" :index="movie.id" 
                v-on:edit-movie="editMovie(movie.id)" 
                v-on:deleteMovie="deleteMovie(movie.id)"
                v-on:updateM="updateMovie(movie.id)">
                </movie>
            </div>      
        </div>

    </div> 
</template>

<script>
import Movie from './movie'

export default {
    name: 'displayMovies',
    components: {
        Movie
    },
    data() {
        return {
            search: "",
            title: '',
            release: '',
            realisator: "",
            synopsis: "",
            toggleMovies: false,
            toggleMovieInfos: false,
            movies: [{id:0, title: '', release: '', language: '', genre: '', director: '', synopsis: '', note: 0, image: ''}],
        };
    },
    mounted() {
        window.axios
        .get('http://127.0.0.1:3000/api/movies/all')
        .then(response => 
        (this.movies = response.data))
        .catch(error => {
        console.log(error)
        })
        
    },
    methods: {
        editMovie(index){
            this.movies[index].title = this.title;  
            this.$router.push({ name: 'editMovie', params: { index: index } });                
        },

        deleteMovie(index)
        {
            window.axios
            .post('http://127.0.0.1:3000/api/movies/'+index+'/delete', this.movie)
            .then(response => (console.log(response)))
            .catch(error => {
            console.error(error)
            });
            
            this.movies.splice(index, 1);      
        },

        GoToAddMovie(){
            this.$router.push({name: 'addMovie'});                
        },

    },
    computed: {
        filteredMovie(){
            return this.movies.filter(movie => {
                return movie.title.toUpperCase().includes(this.search.toUpperCase()) 
                || movie.director.toUpperCase().includes(this.search.toUpperCase()) 
                || movie.release.toString().includes(this.search) 
            });
        }
    }
}
</script>

<style>

#index{
    background-color: rgb(5, 5, 5);
} 

.custom-title{
    font-size: 6rem;
    font-family: 'Times New Roman', Times, serif;
}

.search{
    min-height:600px;

}

.search .v-text-field{
    font-size: 30px;
}

.search .content{
    width: 40vw;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
}

.movies{
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    padding: 50px;
    justify-content: space-around;
}

.movie{
    display: flex;
    justify-content: center;
    flex-basis: 33.333333%;
    padding-bottom: 50px;
}


</style>
